<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: ALM_RequerimientoDetalleLote.xml */
/* Generado: 2020-08-18 04:21:24 */

/* Mantenimiento de los registros de la tabla ALM_RequerimientoDetalleLote */
abstract class BaseALM_RequerimientoDetalleLoteDP extends ALM_RequerimientoDetalleLoteBV
{
    /* Constructor ( Establece los valores desde un objeto ALM_RequerimientoDetalleLoteBN ) */
    public function __construct( ALM_RequerimientoDetalleLoteBN $o_ALM_RequerimientoDetalleLoteBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_ALM_RequerimientoDetalleLoteBN ) )
        {
            $this->setByBN( $o_ALM_RequerimientoDetalleLoteBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto ALM_RequerimientoDetalleLoteBN */
    public function setByBN( ALM_RequerimientoDetalleLoteBN $o_ALM_RequerimientoDetalleLoteBN )
    {
        if ( !is_null( $o_ALM_RequerimientoDetalleLoteBN->getIdRequerimientoDetalleLote() ) )
        {
            $this->setIdRequerimientoDetalleLote( $o_ALM_RequerimientoDetalleLoteBN->getIdRequerimientoDetalleLote() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLoteBN->getIdRequerimientoDetalle() ) )
        {
            $this->setIdRequerimientoDetalle( $o_ALM_RequerimientoDetalleLoteBN->getIdRequerimientoDetalle() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLoteBN->getIdLote() ) )
        {
            $this->setIdLote( $o_ALM_RequerimientoDetalleLoteBN->getIdLote() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLoteBN->getFechaVencimiento() ) )
        {
            $this->setFechaVencimiento( $o_ALM_RequerimientoDetalleLoteBN->getFechaVencimiento() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLoteBN->getCantidad() ) )
        {
            $this->setCantidad( $o_ALM_RequerimientoDetalleLoteBN->getCantidad() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLoteBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_ALM_RequerimientoDetalleLoteBN->getFechaCreacion() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLoteBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_ALM_RequerimientoDetalleLoteBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLoteBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_ALM_RequerimientoDetalleLoteBN->getFechaModificacion() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLoteBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_ALM_RequerimientoDetalleLoteBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_ALM_RequerimientoDetalleLoteFN = new ALM_RequerimientoDetalleLoteFN();
        $o_ALM_RequerimientoDetalleLoteBN = $o_ALM_RequerimientoDetalleLoteFN->selectByPk( $this->getIdRequerimientoDetalleLote() );
        if ( is_null( $o_ALM_RequerimientoDetalleLoteBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO ALM_RequerimientoDetalleLote ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdRequerimientoDetalleLote() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdRequerimientoDetalleLote";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdRequerimientoDetalleLote()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRequerimientoDetalle() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdRequerimientoDetalle";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdRequerimientoDetalle()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdLote() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdLote";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdLote()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaVencimiento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaVencimiento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaVencimiento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidad() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Cantidad";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE ALM_RequerimientoDetalleLote SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdRequerimientoDetalle() ) )
            {
                $s_SQLQuery .= $s_Separator."IdRequerimientoDetalle = ".$this->getIdRequerimientoDetalle()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdLote() ) )
            {
                $s_SQLQuery .= $s_Separator."IdLote = '".$this->getIdLote()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaVencimiento() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaVencimiento = '".$this->getFechaVencimiento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidad() ) )
            {
                $s_SQLQuery .= $s_Separator."Cantidad = ".$this->getCantidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdRequerimientoDetalleLote = ".$this->getIdRequerimientoDetalleLote().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM ALM_RequerimientoDetalleLote WHERE  IdRequerimientoDetalleLote = ".$this->getIdRequerimientoDetalleLote().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>